## vifm 0.7.8

=== tests/Makefile ===
include detectenv.mk

dirs := colmgr commands column_view completion env escape filetype filter
dirs += keys misc options parsing undo variables viewcolumns_parser
dirs += ioeta ionotif iop ior
# generate names for build sub-targets (one for each directory)
dirs_b := $(addsuffix _b, $(dirs))
# generate names for clean sub-targets (one for each directory)
dirs_c := $(addsuffix _c, $(dirs))

.PHONY: tests clean $(dirs) $(dirs_b) $(dirs_c)

tests: bin $(dirs_b)
	@for test in bin/*; do\
		echo '==================================================';\
		echo Test Suite: $$test;\
		echo '==================================================';\
		echo;\
		echo;\
		if ! $$test; then\
			exit 1;\
		fi;\
		echo;\
		echo;\
		echo;\
	done

$(dirs_b): bin
	$(MAKE) --directory=$(subst _b,,$@) --makefile=../Makefile.inc

$(dirs): bin
	$(MAKE) --directory=$@ --makefile=../Makefile.inc
ifdef UNIX_ENV
	@test=bin/$@;\
	echo '==================================================';\
	echo Test Suite: $$test;\
	echo '==================================================';\
	$$test
else
	@test=bin/$@.exe;\
	echo '==================================================';\
	echo Test Suite: $$test;\
	echo '==================================================';\
	$$test
endif

bin:
	mkdir $@

clean: $(dirs_c)
	-$(RM) -r bin/
	-$(RM) seatest/*.o seatest/*.d

$(dirs_c):
	$(MAKE) --directory=$(subst _c,,$@) --makefile=../Makefile.inc clean

=== tests/parsing/Makefile ===
SOURCES := ../../parsing.c

include ../Makefile.inc

=== tests/viewcolumns_parser/Makefile ===
SOURCES := ../../parser.c

include ../Makefile.inc

=== debian/changelog ===
vifm (0.7.8-3build1) xenial; urgency=medium

  * No-change rebuild for ncurses6 transition.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Feb 2016 12:48:52 +0000

vifm (0.7.8-3) unstable; urgency=medium

  * Added patch to fix building on arm-archs
    Thanks to xaizek for providing another fix very quickly!

 -- Hendrik Jaeger <deb@henk.geekmail.org>  Sun, 26 Oct 2014 11:41:34 +0100

vifm (0.7.8-2) unstable; urgency=medium

  * Removed non-functional 'make tests' fixup in debian/rules
  * Added patch to fix building without terminal
    Thanks to xaizek for providing the patch so quickly

 -- Hendrik Jaeger <deb@henk.geekmail.org>  Sun, 26 Oct 2014 01:42:39 +0200

vifm (0.7.8-1) unstable; urgency=medium

  * [54b44c8] New Upstream version 0.7.8 (Upload to unstable)
  * [ffc0b9c] Changed Standards-Version from 3.9.4 to 3.9.6 in debian/control
  * [8f0860c] Changed path in debian/install to reflect upstream changes
  * [feaa914] Changed Homepage in debian/control to http://vifm.info/
  * [08a6d6f] Changed Source and Upstream-Contact in debian/copyright
  * [f0e76b8] Changed Copyright time period in debian/copyright
  * [085c125] Added missing Copyright holder to debian/copyright
  * [75c7b88] Added missing license information in debian/copyright
  * [f21acf8] Added support for -beta releases to debian/watch
  * [d8d0029] Added override in debian/rules to make tests work
  * [a73f042] Added locale setting in debian/rules to fix manpage generation
  * [da21229] Added dh_autoreconf to fix build for new archs (Closes: #748283)
  * [5a97013] Added dynamic support for X11
  * [157f3d9] Added explicit --without-gtk to configure call in debian/rules
  * [f927fb2] Added vim as Build-Dependency for helptags generation
  * [2b3754c] Removed debian/clean, obsoleted by upstream.
  * [32d0e01] Removed obsolete patch from debian/patches/series
  * [9560a73] Removed obsolete patchfiles

 -- Hendrik Jaeger <deb@henk.geekmail.org>  Sat, 25 Oct 2014 20:39:52 +0200

vifm (0.7.4a-1~exp2) experimental; urgency=low

  * Removed unnecessary build-dependency on 'quilt'
  * Added options to configure call to avoid extra dependencies:
    - --without-X11
    - --without-gtk

 -- Hendrik Jaeger <deb@henk.geekmail.org>  Mon, 26 Nov 2012 23:14:45 +0100

vifm (0.7.4a-1~exp1) experimental; urgency=low

  * New maintainer (Closes: #682456)
  * New upstream release (Closes: #577280):
    - vifm-pause script was renamed (Closes: #592562)
    - proper utf8-support has been included (Closes: #526253, #495805)
    - possible buffer overflow fixed, debian-dir cleaned up (Closes: #520458)
    - dirs with spaces are now handled correctly (Closes: #483474)
  * Added patches to fix tests
    - tests/Makefile.inc: add include to find curses.h
  * Added debian/clean to delete build-leftovers
  * Added debian/compat to state compatibility with debhelper 9
  * Added homepage to package description
  * Added debian/install to install the vifm-plugin for vim where it can be
    used with vim-addon-manager
  * Added debian/menu to have vifm show up in autogenerated menus
  * Added debian/source/format with "3.0 (quilt)"
  * Added needed files to vim-vifm.yaml
  * Changed debian policy version to 3.9.4
  * Changed package description text to be more informative
  * Changed debian/copyright to be machine parsable (DEP-5)
  * Changed debian/rules to use dh for everything
  * Changed debian/watch to correct format and file extension
  * Changed dependency to libncursesw5-dev

 -- Hendrik Jaeger <deb@henk.geekmail.org>  Sun, 23 Sep 2012 02:10:58 +0200

vifm (0.4-1) unstable; urgency=low

  * new upstream release with UTF-8 support (Closes: #495805)

 -- Edelhard Becker <edelhard@debian.org>  Thu, 11 Sep 2008 22:35:37 +0200

vifm (0.3a-3) unstable; urgency=low

  * make vifm build-depend on automake and libtool (Closes: #477735)

 -- Edelhard Becker <edelhard@debian.org>  Fri, 25 Apr 2008 21:55:56 +0200

vifm (0.3a-2) unstable; urgency=low

  * okay, okay, with vim-addon-manager we don't need a postinst with helpztags
    any more ...

 -- Edelhard Becker <edelhard@debian.org>  Tue, 22 Apr 2008 17:35:55 +0200

vifm (0.3a-1) unstable; urgency=low

  * new upstream release
  * debian/rules: call autogen.sh, fixed clean target
  * fixed debian/watch file (Closes: #450233)
  * added patches from CVS
  * bump standards to 3.7.3 (no changes)
  * depend on vim|vim-tiny, install helpfile in /usr/share/vim/addons/doc,
    vifm.vim in /usr/share/vim/addons/plugin and use vim-addon-manager for
    local and system-wide installation (Closes: #443479); do not install both
    as conffiles anymore
  * look for DEB_BUILD_OPTIONS=nostrip (Closes: #438245)

 -- Edelhard Becker <edelhard@debian.org>  Mon, 21 Apr 2008 15:40:09 +0200

vifm (0.3-2) unstable; urgency=low

  * ACK NMU, thanks Blars (Closes: #320118)

 -- Edelhard Becker <edelhard@debian.org>  Tue,  9 Aug 2005 15:15:09 +0200

vifm (0.3-1.1) unstable; urgency=low

  * NMU durring BSP
  * add build-depend on automake1.7 (Closes: #320118)

 -- Blars Blarson <blarson@debian.org>  Fri,  5 Aug 2005 19:37:55 +0000

vifm (0.3-1) unstable; urgency=low

  * New upstream release
  * removed CC=cc from debian/rules (broke with libtool --tag)
  * remove CVS dirs from upstream tarball

 -- Edelhard Becker <edelhard@debian.org>  Tue, 19 Jul 2005 15:30:01 +0200

vifm (0.2a-2) unstable; urgency=low

  * Renamed pauseme to vifm-pauseme (making a diversion or putting it into a
    seperate package just seems to be too much effort for a 8-line shell
    script, IMHO; Closes: #274782: file conflicts in vifm tkdesk).

 -- Edelhard Becker <edelhard@debian.org>  Mon,  4 Oct 2004 11:35:25 +0200

vifm (0.2a-1) unstable; urgency=low

  * New upstream release (thanks Jeroen van Wolffelaar for the hint)
  * changed Maintainer to my debian account
  * updated standards to 3.6.1 (no changes needed)
  * removed CVS directories from source

 -- Edelhard Becker <edelhard@debian.org>  Wed, 29 Sep 2004 18:00:36 +0200



=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export LC_ALL=C.UTF-8

%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --with-X11 --with-dyn-X11 --without-gtk

override_dh_auto_test:
	make -j1 check

override_dh_shlibdeps:
	dh_shlibdeps -- -xlibx11-6

=== debian/watch ===
version=3
# X.Y.Z-beta comes before X.Y.Z
opts=uversionmangle=s/-/~/ \
    http://sf.net/vifm/vifm-(.*)\.tar\.bz2

## vifm 0.8.2

=== tests/Makefile ===
# Overview
# --------
#
# This is a non-recursive Makefile for running vifm tests using stic.
#
# Vifm is built before running any tests as its object files are used for tests.
# Necessary include and link directives are picked up from the main Makefile.
#
# Each test-suite (directory) is run in a separate sandbox directory.  During
# compilation two defines are available:
#  - TEST_DATA_PATH -- absolute path to test-data/ directory (might be RO)
#  - SANDBOX_PATH   -- absolute path to sandbox for the suite (always RW)
#
# Test suites can be run concurrently.
#
# Usage
# -----
#
# By default tests are built in release mode.
#
# make              -- builds and runs all tests
# make build        -- builds all tests without running them
# make <dir>        -- runs specific test suite
# make <dir>.<name> -- runs specific fixture
#
# make DEBUG=1 ...        -- builds debug version
# make DEBUG=gdb ...      -- builds debug version and loads suite into gdb
# make DEBUG=valgrind ... -- builds debug version and run it under valgrind (see
#                            valgrind-report file after a run)
#
# make VERBOSE=1 ... -- print all build commands
#
# make TEST_RUN_PREFIX=wine -- run command prefix
#
# make clean -- removes various built artifacts
#
# "B" variable might be set to build tree root to run tests out of the source
# tree.

# determine kind of OS that is running
ifeq ($(OS),Windows_NT)
    ifeq ($(shell uname -o 2> /dev/null),Cygwin)
        unix_env := true
    else
        win_env := true
    endif
else
    ifeq ($(CROSS),)
        unix_env := true
    else
        win_env := true
    endif
endif

ifdef DEBUG
    BINSUBDIR := debug/
endif

# path to build tree
B ?=
# path to storage for intermediate build files
BUILD := $(B)bin/build/$(BINSUBDIR)

# engine
suites += abbrevs autocmds commands completion keys options parsing variables
# io
suites += ioeta ionotif iop ior
# ui
suites += colmgr column_view viewcolumns_parser
# everything else
suites += bmarks env escape fileops filetype filter misc undo utils

# obtain list of sources that are being tested
vifm_src := ./ cfg/ compat/ engine/ int/ io/ io/private/ modes/dialogs/ menus/
vifm_src += modes/ ui/ utils/
vifm_src := $(wildcard $(addprefix ../src/, $(addsuffix *.c, $(vifm_src))))
vifm_src := $(filter-out %/tags.c, $(vifm_src))

# filter out generally non-testable or sources for another platform
vifm_src := $(filter-out %/vifm.c %/win_helper.c, $(vifm_src))
ifndef unix_env
    vifm_src := $(filter-out %/desktop.c %/mntent.c %_nix.c, $(vifm_src))
endif
ifndef win_env
    vifm_src := $(filter-out %/wcwidth.c %/volumes_menu.c %_win.c, $(vifm_src))
endif

vifm_bin := $(B)../src/vifm$(exe_suffix)
vifm_obj := $(B)../src/./tags.o $(vifm_src:%.c=$(B)%.o) $(BUILD)stubs.o

# make sure that there is one compile_info.c object file in the list
vifm_obj := $(filter-out %/compile_info.o, $(vifm_obj))
vifm_obj += $(B)../src/compile_info.o

ifdef unix_env
    make_args := -C $(B)../src/
endif
ifdef win_env
    make_args  := -C $(B)../src/ -f $(abspath ../src/Makefile.win)
    exe_suffix := .exe
endif

CC = gcc

# handling of verbosity (non-verbose by default)
ifdef VERBOSE
    V = 1
else
    V = 0
endif
ACTUAL_CC := $(CC)
CC_0 = @echo "Compiling $@..."; $(ACTUAL_CC)
CC_1 = $(ACTUAL_CC)
LD_0 = @echo "Linking $@..."; $(ACTUAL_CC)
LD_1 = $(ACTUAL_CC)
AT_0 = @
AT_1 =
# redefine commands according to verbosity state
override CC = $(CC_$(V))
override LD = $(LD_$(V))
AT = $(AT_$(V))

# setup compile and link flags (partially depends on OS)
CFLAGS := -MMD -pipe -Wall -Werror -Istic/ -DTEST -include $(B)../config.h
CFLAGS += -D_XOPEN_SOURCE -D_XOPEN_SOURCE_EXTENDED -Wno-char-subscripts
CFLAGS += -D_FILE_OFFSET_BITS=64 -fsigned-char
LDFLAGS := -lpthread
ifeq (,$(findstring clang,$(CC)))
    # clang is inconvenient with regard to this flag, don't do coverage with it
    LDFLAGS += --coverage
endif
ifdef unix_env
    MF := $(B)../src/Makefile
    ifneq ($(wildcard $(MF)),)
        LDFLAGS += $(shell grep -m1    'LIBS =' $(MF) | sed 's/^[^=]*=//')
        LDFLAGS += $(shell grep -m1 'LDFLAGS =' $(MF) | sed 's/^[^=]*=//')

        CFLAGS  += $(shell grep -m1          'CPPFLAGS =' $(MF) | sed 's/^[^=]*=//')
        CFLAGS  += $(shell grep -m1      'TESTS_CFLAGS =' $(MF) | sed 's/^[^=]*=//')
        CFLAGS  += $(shell grep -m1 'SANITIZERS_CFLAGS =' $(MF) | sed 's/^[^=]*=//')
    endif

    CFLAGS += -I/usr/include/ncursesw
    export UBSAN_OPTIONS := halt_on_error=1
endif
ifdef win_env
    LDFLAGS += $(shell sed -n '/LIBS :=/{s/^[^=]\+=//p;q}' ../src/Makefile.win)
    # this part is in conditional
    ifeq ($(OS),Windows_NT)
        LDFLAGS += -lpdcurses
    else
        LDFLAGS += -lcurses
    endif
endif

ifdef DEBUG
    CFLAGS += -g
    LDFLAGS += -g
    ifdef unix_env
        LDFLAGS += -rdynamic
    endif

    ifeq ($(DEBUG),gdb)
        TEST_RUN_PREFIX := gdb --args
    endif
    ifeq ($(DEBUG),valgrind)
        TEST_RUN_PREFIX := valgrind --track-origins=yes --leak-check=full \
                           --log-file=valgrind-report --error-exitcode=5 \
                           --suppressions=$(abspath .)/../.valgrind.supp
        TEST_RUN_POST := || (e=$$$$?; if [ $$$$e -eq 5 ]; then \
                                          cat valgrind-report; \
                                      fi; \
                                      exit $$$$e)
    endif
endif

.PHONY: check build clean $(suites)

# check and build targets are defined mostly in suite_template
check: build

clean:
	$(RM) -r $(B)bin/ $(SANDBOX_PATH)/
	$(RM) $(B)stic/stic.h.d $(B)stic/stic.h.gch

# disable implicit rules to prevent compiling main sources here
.SUFFIXES:

$(vifm_obj) ../src/./tags.c: | $(vifm_bin)

$(vifm_bin): $(vifm_src)
	$(MAKE) $(make_args) vifm$(exe_suffix)

$(BUILD)stubs.o: stubs.c
	$(CC) -c -o $@ $(CFLAGS) $<

$(BUILD)stic.o: stic/stic.c
	$(CC) -c -o $@ $(CFLAGS) $<

$(B)stic/stic.h.gch: stic/stic.h | $(B)stic
# don't precompile header with clang (on OS X gcc is likely to be a symlink to
# clang) because it handles macros in a different way
ifeq (,$(findstring clang,$(CC)))
ifneq (Darwin,$(shell uname -s))
	$(CC) -c -o $@ $(CFLAGS) $<
endif
endif

$(B)stic $(B)bin/$(BINSUBDIR):
	$(AT)mkdir -p $@

# this function of two arguments (array and element) returns index of the
# element in the array
pos = $(strip $(eval T := ) \
              $(eval i := 0) \
              $(foreach elem, $1, \
                        $(if $(filter $2,$(elem)), \
                             $(eval i := $(words $T)), \
                             $(eval T := $T $(elem)))) \
              $i)

ifeq (,$(findstring wine,$(TEST_RUN_PREFIX)))
    ifeq ($B,)
        SANDBOX_PATH := $(abspath .)/sandbox
    else
        SANDBOX_PATH := $(B)sandbox
    endif
    TEST_DATA_PATH := $(abspath .)/test-data
else
    SANDBOX_PATH := sandbox
    TEST_DATA_PATH := test-data
endif


# suite definition template, takes single argument: name of the suite
define suite_template

$1.src := $$(sort $$(wildcard $1/*.c))
$1.obj := $$($1.src:%.c=$(BUILD)%.o)
$1.bin := $(B)bin/$(BINSUBDIR)$1$(exe_suffix)
$1.fixtures := $$(subst /,.,\
                        $$(patsubst %.c,%,$$(filter-out %/suite.c,$$($1.src))))

deps += $$($1.obj:.o=.d)

$$($1.bin): $$($1.obj) $(BUILD)stic.o $(vifm_obj) \
          | $(vifm_bin) $(B)bin/$(BINSUBDIR)
	$$(LD) -o $$@ $$^ $(LDFLAGS)

$(BUILD)$1/%.o: $1/%.c $(B)stic/stic.h.gch $(BUILD)$1/filelist \
              | $(BUILD)$1 $(SANDBOX_PATH)/$1
	$$(CC) -c -o $$@ -include stic/stic.h $(CFLAGS) \
	                 -DTESTID=$$(call pos, $$($1.obj), $$@) \
	                 -DMAXTESTID=$$(words $$($1.obj)) $$< \
	                 -DSUITE_NAME="$1" \
	                 -DTEST_DATA_PATH='"$(TEST_DATA_PATH)"' \
	                 -DSANDBOX_PATH='"$(SANDBOX_PATH)/$1"' \

$(BUILD)$1/filelist: $1/. | $(BUILD)$1
	@if [ ! -f "$$@" -o "$$$$(cat $$@ 2> /dev/null)" != '$$($1.src)' ]; then \
		echo -n '$$($1.src)' > $$@; \
	fi

$(BUILD)$1 $(SANDBOX_PATH)/$1:
	$(AT)mkdir -p $$@

$1: $$($1.bin)
ifeq ($B,)
	@$(TEST_RUN_PREFIX) $$^ -s $(TEST_RUN_POST)
else
	@cd $B && $(TEST_RUN_PREFIX) $$^ -s $(TEST_RUN_POST)
endif

# this runs separate fixtures, targets are of the form dir.name
.PHONY: $$($1.fixtures)
$$($1.fixtures): $$($1.bin)
ifeq ($B,)
	@$(TEST_RUN_PREFIX) $$^ -s -f $$(subst .,/,$$@).c $(TEST_RUN_POST)
else
	@cd $B && $(TEST_RUN_PREFIX) $$^ -s -f $$(subst .,/,$$@).c $(TEST_RUN_POST)
endif

build: $$($1.bin)

check: $1

endef

# walk throw list of suites and instantiate template for each one
$(foreach suite, $(suites), $(eval $(call suite_template,$(suite))))

# import dependencies calculated by the compiler
include $(wildcard $(deps) \
                   $(B)bin/build/stic.d $(B)stic/stic.h.d $(B)bin/build/stubs.d)

=== debian/changelog ===
vifm (0.8.2-1) unstable; urgency=medium

  * New upstream release
  * Uploading to unstable
  * Migrated to git-dpm
  * Removed d/p/filetype_unit_test_fix.patch (applied upstream)

 -- Ondřej Nový <onovy@debian.org>  Thu, 21 Jul 2016 21:40:14 +0200

vifm (0.8.2~beta-1) experimental; urgency=medium

  * New upstream release
  * d/{control,copyright}: Use my @debian.org email address
  * Removed all patches, applied upstream
  * Upstream url changed to https protocol
  * Added filetype_unit_test_fix.patch

 -- Ondřej Nový <onovy@debian.org>  Mon, 04 Jul 2016 13:36:26 +0200

vifm (0.8.1a-1) unstable; urgency=medium

  * New maintainer (Closes: #824002)
  * wrap-and-sort -t -a
  * Added Vcs-* fields pointing to the collab-maint repository
  * Fixed vim plugin (Closes: #770195)
  * Removed redundant files from /usr/share/vifm

 -- Ondřej Nový <novy@ondrej.org>  Wed, 11 May 2016 23:20:03 +0200

vifm (0.8.1a-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Removed override_dh_auto_test which prevented to see errors from tests
  * Added patches from upstream:
    - use_CFLAGS_passed_to_configure_in_tests.patch
    - fix_for_architectures_on_which_char_is_unsigned.patch
    - use_return_value_of_chdir_in_misc_tests.patch
  * Enabled all PIE hardening

 -- Ondřej Nový <novy@ondrej.org>  Tue, 03 May 2016 23:37:52 +0200

vifm (0.8.1a-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release (Closes: #812797, #810630)
  * Removed 0001-fix-building-without-terminal.patch
    (Applied upstream)
  * Removed 0002-Fix-buffer-overflow-in-tests-to-fix-building-on-arm.patch
    (Applied upstream)
  * Standards-Version is 3.9.8 now (no change)
  * d/copyright:
    - Fixed for new release
    - Added myself for Debian part
  * Removed superfluous doc files (COPYING, INSTALL and ChangeLog)
  * Removed d/menu, .desktop file is installed instead
  * Added simple Debian test
  * Enabled all but PIE hardening
  * Added disable-build-timestamp option to perform reproducible build

 -- Ondřej Nový <novy@ondrej.org>  Sat, 09 Apr 2016 19:27:44 +0200

=== debian/control ===
Source: vifm
Section: utils
Priority: optional
Maintainer: Ondřej Nový <onovy@debian.org>
Build-Depends: debhelper (>= 9),
               dh-autoreconf,
               libmagic-dev,
               libncursesw5-dev,
               libx11-dev,
               vim,
Standards-Version: 3.9.8
Homepage: https://vifm.info/
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/vifm.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/vifm.git

Package: vifm
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Recommends: libx11-6,
            vim-addon-manager,
Description: flexible vi-like file manager using ncurses
 Vifm is a file manager providing a vi-like usage experience. It has similar
 keybindings and modes (e.g. normal, command line, visual). The interface uses
 ncurses, thus vifm can be used in text-only environments.
 It supports a wide range of features, some of which are known from the
 vi-editor:
  - utf8 support
  - user mappings (almost like in vi)
  - ranges in command-line commands
  - user defined commands (with support for ranges)
  - registers
  - operation undoing/redoing
  - fuse file systems support
  - trash
  - multiple files renaming
  - support of filename modifiers
  - colorschemes support
  - file name color according to file type
  - path specific colorscheme customization
  - bookmarks
  - operation backgrounding
  - customizable file viewers
  - handy less-like preview mode
  - filtering out and searching for files using regular expressions
  - one or two panes view
 With the package comes a plugin to use vifm as a vim file selector.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export LC_ALL=C.UTF-8
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --with-X11 --with-dyn-X11 --without-gtk --disable-build-timestamp

override_dh_shlibdeps:
	dh_shlibdeps -- -xlibx11-6

override_dh_install:
	rm -r \
		debian/vifm/usr/share/doc/vifm/COPYING \
		debian/vifm/usr/share/doc/vifm/INSTALL \
		debian/vifm/usr/share/doc/vifm/ChangeLog \
		debian/vifm/usr/share/vifm/vim \
		debian/vifm/usr/share/vifm/vim-doc \
		debian/vifm/usr/share/vifm/vifm-help.txt \
		debian/vifm/usr/share/vifm/vifmrc-osx

	dh_install --fail-missing

## vifm 0.9

=== debian/changelog ===
vifm (0.9-1) unstable; urgency=medium

  * New upstream release
  * Bump debhelper version to 10
  * Check upstream tarball signature

 -- Ondřej Nový <onovy@debian.org>  Tue, 20 Jun 2017 16:58:33 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,7 @@
 Section: utils
 Priority: optional
 Maintainer: Ondřej Nový <onovy@debian.org>
-Build-Depends: debhelper (>= 9),
-               dh-autoreconf,
+Build-Depends: debhelper (>= 10),
                libmagic-dev,
                libncursesw5-dev,
                libx11-dev,

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
-	dh $@ --with autoreconf
+	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure -- --with-X11 --with-dyn-X11 --without-gtk --disable-build-timestamp

## vifm 0.9.1

=== tests/Makefile ===
--- 
+++ 
@@ -8,8 +8,8 @@
 #
 # Each test-suite (directory) is run in a separate sandbox directory.  During
 # compilation two defines are available:
-#  - TEST_DATA_PATH -- absolute path to test-data/ directory (might be RO)
-#  - SANDBOX_PATH   -- absolute path to sandbox for the suite (always RW)
+#  - TEST_DATA_PATH -- path to test-data/ directory (might be RO)
+#  - SANDBOX_PATH   -- path to sandbox for the suite (always RW)
 #
 # Test suites can be run concurrently.
 #
@@ -20,19 +20,21 @@
 #
 # make              -- builds and runs all tests
 # make build        -- builds all tests without running them
+# make check        -- builds all tests and then runs them
 # make <dir>        -- runs specific test suite
 # make <dir>.<name> -- runs specific fixture
 #
 # make DEBUG=1 ...        -- builds debug version
 # make DEBUG=gdb ...      -- builds debug version and loads suite into gdb
-# make DEBUG=valgrind ... -- builds debug version and run it under valgrind (see
-#                            valgrind-report file after a run)
-#
-# make VERBOSE=1 ... -- print all build commands
-#
-# make TEST_RUN_PREFIX=wine -- run command prefix
-#
-# make clean -- removes various built artifacts
+# make DEBUG=rr ...       -- builds debug version and loads suite into rr
+# make DEBUG=valgrind ... -- builds debug version and runs it under valgrind
+#                            (see valgrind-report file after a run)
+#
+# make VERBOSE=1 ... -- enables verbose printing of commands
+#
+# make TEST_RUN_PREFIX=wine -- sets run command prefix
+#
+# make clean -- removes various build artifacts
 #
 # "B" variable might be set to build tree root to run tests out of the source
 # tree.
@@ -62,19 +64,20 @@
 BUILD := $(B)bin/build/$(BINSUBDIR)
 
 # engine
-suites += abbrevs autocmds commands completion keys options parsing variables
+suites += abbrevs autocmds commands completion keys options parsing text_buffer
+suites += variables
 # io
 suites += ioeta ionotif iop ior
 # ui
 suites += colmgr column_view viewcolumns_parser
 # everything else
-suites += bmarks env escape fileops filetype filter misc undo utils
+suites += bmarks env escape fileops filetype filter fuzz misc undo utils
 
 # obtain list of sources that are being tested
 vifm_src := ./ cfg/ compat/ engine/ int/ io/ io/private/ modes/dialogs/ menus/
 vifm_src += modes/ ui/ utils/
 vifm_src := $(wildcard $(addprefix ../src/, $(addsuffix *.c, $(vifm_src))))
-vifm_src := $(filter-out %/tags.c, $(vifm_src))
+vifm_src := $(filter-out %/tags.c %/xxhash.c, $(vifm_src))
 
 # filter out generally non-testable or sources for another platform
 vifm_src := $(filter-out %/vifm.c %/win_helper.c, $(vifm_src))
@@ -121,52 +124,63 @@
 AT = $(AT_$(V))
 
 # setup compile and link flags (partially depends on OS)
-CFLAGS := -MMD -pipe -Wall -Werror -Istic/ -DTEST -include $(B)../config.h
-CFLAGS += -D_XOPEN_SOURCE -D_XOPEN_SOURCE_EXTENDED -Wno-char-subscripts
-CFLAGS += -D_FILE_OFFSET_BITS=64 -fsigned-char
-LDFLAGS := -lpthread
+override CFLAGS := $(CFLAGS) -MMD -pipe -Wall -Wno-char-subscripts \
+                   -Istic/ -include $(B)../build-aux/config.h -fsigned-char \
+                   -DTEST -D_XOPEN_SOURCE -D_XOPEN_SOURCE_EXTENDED \
+                   -D_FILE_OFFSET_BITS=64
+override LDFLAGS := $(LDFLAGS)
 ifeq (,$(findstring clang,$(CC)))
     # clang is inconvenient with regard to this flag, don't do coverage with it
-    LDFLAGS += --coverage
+    override LDFLAGS += --coverage
 endif
 ifdef unix_env
-    MF := $(B)../src/Makefile
+    MF := $(abspath $(B)../src/Makefile)
     ifneq ($(wildcard $(MF)),)
-        LDFLAGS += $(shell grep -m1    'LIBS =' $(MF) | sed 's/^[^=]*=//')
-        LDFLAGS += $(shell grep -m1 'LDFLAGS =' $(MF) | sed 's/^[^=]*=//')
-
-        CFLAGS  += $(shell grep -m1          'CPPFLAGS =' $(MF) | sed 's/^[^=]*=//')
-        CFLAGS  += $(shell grep -m1      'TESTS_CFLAGS =' $(MF) | sed 's/^[^=]*=//')
-        CFLAGS  += $(shell grep -m1 'SANITIZERS_CFLAGS =' $(MF) | sed 's/^[^=]*=//')
-    endif
-
-    CFLAGS += -I/usr/include/ncursesw
+        override LDFLAGS += \
+            $(shell grep -m1    'LIBS =' $(MF) | sed 's/^[^=]*=//') \
+            $(shell grep -m1 'LDFLAGS =' $(MF) | sed 's/^[^=]*=//')
+
+        override CFLAGS  += \
+            $(shell grep -m1          'CPPFLAGS =' $(MF) | sed 's/^[^=]*=//') \
+            $(shell grep -m1      'TESTS_CFLAGS =' $(MF) | sed 's/^[^=]*=//') \
+            $(shell grep -m1 'SANITIZERS_CFLAGS =' $(MF) | sed 's/^[^=]*=//')
+    endif
+
+    override CFLAGS += -I/usr/include/ncursesw
     export UBSAN_OPTIONS := halt_on_error=1
 endif
 ifdef win_env
-    LDFLAGS += $(shell sed -n '/LIBS :=/{s/^[^=]\+=//p;q}' ../src/Makefile.win)
-    # this part is in conditional
+    override CFLAGS += -pthread
+    override LDFLAGS += \
+        $(shell sed -n '/LIBS :=/{s/^[^=]\+=//p;q}' ../src/Makefile.win)
+    # this part is in conditional of ../src/Makefile.win
     ifeq ($(OS),Windows_NT)
-        LDFLAGS += -lpdcurses
+        override LDFLAGS += -lpdcurses
     else
-        LDFLAGS += -lcurses
-    endif
+        override LDFLAGS += -lcurses
+    endif
+endif
+ifeq (,$(findstring -lpthread,$(LDFLAGS)))
+    override LDFLAGS += -pthread
 endif
 
 ifdef DEBUG
-    CFLAGS += -g
-    LDFLAGS += -g
+    override CFLAGS += -g -O0
+    override LDFLAGS += -g
     ifdef unix_env
-        LDFLAGS += -rdynamic
+        override LDFLAGS += -rdynamic
     endif
 
     ifeq ($(DEBUG),gdb)
-        TEST_RUN_PREFIX := gdb --args
+        TEST_RUN_PREFIX := gdb -q --args
+    endif
+    ifeq ($(DEBUG),rr)
+        TEST_RUN_PREFIX := rr record
     endif
     ifeq ($(DEBUG),valgrind)
         TEST_RUN_PREFIX := valgrind --track-origins=yes --leak-check=full \
                            --log-file=valgrind-report --error-exitcode=5 \
-                           --suppressions=$(abspath .)/../.valgrind.supp
+                           --suppressions=$(abspath .)/../src/.valgrind.supp
         TEST_RUN_POST := || (e=$$$$?; if [ $$$$e -eq 5 ]; then \
                                           cat valgrind-report; \
                                       fi; \
@@ -178,6 +192,11 @@
 
 # check and build targets are defined mostly in suite_template
 check: build
+	@if [ "$$(find "$(SANDBOX_PATH)" -mindepth 2 | wc -l)" -ne 0 ]; then \
+	    echo "ERROR: sandbox isn't empty"; \
+	    find $(SANDBOX_PATH) -mindepth 2; \
+	    false; \
+	fi
 
 clean:
 	$(RM) -r $(B)bin/ $(SANDBOX_PATH)/
@@ -231,6 +250,10 @@
     TEST_DATA_PATH := test-data
 endif
 
+ifneq ($(shell find "$(SANDBOX_PATH)" -mindepth 2 2> /dev/null | wc -l),0)
+    $(shell $(RM) -r $(SANDBOX_PATH))
+endif
+
 
 # suite definition template, takes single argument: name of the suite
 define suite_template
@@ -261,8 +284,15 @@
 		echo -n '$$($1.src)' > $$@; \
 	fi
 
-$(BUILD)$1 $(SANDBOX_PATH)/$1:
+$(BUILD)$1:
 	$(AT)mkdir -p $$@
+
+$(SANDBOX_PATH)/$1:
+ifeq ($(SANDBOX_PATH),sandbox)
+	$(AT)mkdir -p $(B)$$@
+else
+	$(AT)mkdir -p $$@
+endif
 
 $1: $$($1.bin)
 ifeq ($B,)
@@ -282,7 +312,9 @@
 
 build: $$($1.bin)
 
+ifneq ($1,fuzz)
 check: $1
+endif
 
 endef

=== debian/changelog ===
vifm (0.9.1-1) unstable; urgency=medium

  * New upstream release
  * Use dh_missing --fail-missing
  * Bump Standards-Version to 4.1.3 (no changes needed)
  * d/copyright
    - Change upstream author email
    - Use https for format
  * Bump debhelper compat level to 11
  * d/control: Change Vcs-* to Salsa

 -- Ondřej Nový <onovy@debian.org>  Fri, 09 Feb 2018 14:56:56 +0100

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,15 @@
 Section: utils
 Priority: optional
 Maintainer: Ondřej Nový <onovy@debian.org>
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 11),
                libmagic-dev,
                libncursesw5-dev,
                libx11-dev,
                vim,
-Standards-Version: 3.9.8
+Standards-Version: 4.1.3
 Homepage: https://vifm.info/
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/vifm.git
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/vifm.git
+Vcs-Browser: https://salsa.debian.org/debian/vifm
+Vcs-Git: https://salsa.debian.org/debian/vifm.git
 
 Package: vifm
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -26,4 +26,7 @@
 		debian/vifm/usr/share/vifm/vifm-help.txt \
 		debian/vifm/usr/share/vifm/vifmrc-osx
 
-	dh_install --fail-missing
+	dh_install
+
+override_dh_missing:
+	dh_missing --fail-missing

=== debian/watch ===
version=3
# X.Y.Z-beta comes before X.Y.Z
opts=\
pgpsigurlmangle=s/$/.asc/,\
uversionmangle=s/-/~/ \
    http://sf.net/vifm/vifm-(.*)\.tar\.bz2

## vifm 0.10

=== tests/Makefile ===
--- 
+++ 
@@ -71,7 +71,10 @@
 # ui
 suites += colmgr column_view viewcolumns_parser
 # everything else
-suites += bmarks env escape fileops filetype filter fuzz misc undo utils
+suites += bmarks env escape fileops filetype filter misc undo utils
+
+# these are built, but not automatically executed
+apps := fuzz regs_shmem_app
 
 # obtain list of sources that are being tested
 vifm_src := ./ cfg/ compat/ engine/ int/ io/ io/private/ modes/dialogs/ menus/
@@ -82,7 +85,8 @@
 # filter out generally non-testable or sources for another platform
 vifm_src := $(filter-out %/vifm.c %/win_helper.c, $(vifm_src))
 ifndef unix_env
-    vifm_src := $(filter-out %/desktop.c %/mntent.c %_nix.c, $(vifm_src))
+    vifm_src := $(filter-out %/desktop.c %/media_menu.c %/mntent.c %_nix.c, \
+                             $(vifm_src))
 endif
 ifndef win_env
     vifm_src := $(filter-out %/wcwidth.c %/volumes_menu.c %_win.c, $(vifm_src))
@@ -129,10 +133,6 @@
                    -DTEST -D_XOPEN_SOURCE -D_XOPEN_SOURCE_EXTENDED \
                    -D_FILE_OFFSET_BITS=64
 override LDFLAGS := $(LDFLAGS)
-ifeq (,$(findstring clang,$(CC)))
-    # clang is inconvenient with regard to this flag, don't do coverage with it
-    override LDFLAGS += --coverage
-endif
 ifdef unix_env
     MF := $(abspath $(B)../src/Makefile)
     ifneq ($(wildcard $(MF)),)
@@ -163,6 +163,14 @@
 ifeq (,$(findstring -lpthread,$(LDFLAGS)))
     override LDFLAGS += -pthread
 endif
+ifneq (,$(findstring --coverage, $(LDFLAGS)))
+    ifeq (,$(findstring clang,$(CC)))
+        # clang is inconvenient with regard to this flag, don't do coverage with
+        # it
+        override CFLAGS += --coverage
+        override LDFLAGS += --coverage
+    endif
+endif
 
 ifdef DEBUG
     override CFLAGS += -g -O0
@@ -188,7 +196,7 @@
     endif
 endif
 
-.PHONY: check build clean $(suites)
+.PHONY: check build clean $(suites) $(apps)
 
 # check and build targets are defined mostly in suite_template
 check: build
@@ -296,9 +304,9 @@
 
 $1: $$($1.bin)
 ifeq ($B,)
-	@$(TEST_RUN_PREFIX) $$^ -s $(TEST_RUN_POST)
-else
-	@cd $B && $(TEST_RUN_PREFIX) $$^ -s $(TEST_RUN_POST)
+	@$(TEST_RUN_PREFIX) $$< -s $(TEST_RUN_POST)
+else
+	@cd $B && $(TEST_RUN_PREFIX) $$< -s $(TEST_RUN_POST)
 endif
 
 # this runs separate fixtures, targets are of the form dir.name
@@ -312,14 +320,18 @@
 
 build: $$($1.bin)
 
-ifneq ($1,fuzz)
+# don't add apps to the list of things to run automatically
+ifeq (,$(filter $1,$(apps)))
 check: $1
 endif
 
 endef
 
-# walk throw list of suites and instantiate template for each one
-$(foreach suite, $(suites), $(eval $(call suite_template,$(suite))))
+# walk throw list of suites+apps and instantiate template for each one
+$(foreach suite, $(suites) $(apps), $(eval $(call suite_template,$(suite))))
+
+# extra dependencies between test fixtures
+misc: | $(regs_shmem_app.bin)
 
 # import dependencies calculated by the compiler
 include $(wildcard $(deps) \

=== debian/changelog ===
vifm (0.10-1) unstable; urgency=medium

  * New upstream release

 -- Ondřej Nový <onovy@debian.org>  Fri, 23 Nov 2018 13:15:04 +0100

vifm (0.9.1-2) unstable; urgency=medium

  * d/changelog: Remove trailing newline
  * Use /usr/bin/perl as Perl interpreter
  * Bump standards version to 4.2.1 (no changes)
  * d/watch: Use https protocol
  * Add upstream metadata
  * Install vifm-help.txt (LP: #1774852)

 -- Ondřej Nový <onovy@debian.org>  Sat, 29 Sep 2018 18:21:02 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                libncursesw5-dev,
                libx11-dev,
                vim,
-Standards-Version: 4.1.3
+Standards-Version: 4.2.1
 Homepage: https://vifm.info/
 Vcs-Browser: https://salsa.debian.org/debian/vifm
 Vcs-Git: https://salsa.debian.org/debian/vifm.git

=== debian/rules ===
--- 
+++ 
@@ -23,7 +23,6 @@
 		debian/vifm/usr/share/doc/vifm/ChangeLog \
 		debian/vifm/usr/share/vifm/vim \
 		debian/vifm/usr/share/vifm/vim-doc \
-		debian/vifm/usr/share/vifm/vifm-help.txt \
 		debian/vifm/usr/share/vifm/vifmrc-osx
 
 	dh_install

## vifm 0.10.1

=== tests/Makefile ===
--- 
+++ 
@@ -150,7 +150,7 @@
     export UBSAN_OPTIONS := halt_on_error=1
 endif
 ifdef win_env
-    override CFLAGS += -pthread
+    override CFLAGS += -pthread -DPDC_WIDE
     override LDFLAGS += \
         $(shell sed -n '/LIBS :=/{s/^[^=]\+=//p;q}' ../src/Makefile.win)
     # this part is in conditional of ../src/Makefile.win
@@ -169,6 +169,13 @@
         # it
         override CFLAGS += --coverage
         override LDFLAGS += --coverage
+    endif
+endif
+# don't precompile header with clang (on OS X gcc is likely to be a symlink to
+# clang) because it handles macros in a different way
+ifeq (,$(findstring clang,$(CC)))
+    ifneq (Darwin,$(shell uname -s))
+        GCH_DEP := $(B)stic/stic.h.gch
     endif
 endif
 
@@ -213,7 +220,7 @@
 # disable implicit rules to prevent compiling main sources here
 .SUFFIXES:
 
-$(vifm_obj) ../src/./tags.c: | $(vifm_bin)
+$(vifm_obj) ../src/./tags.c: $(vifm_src) | $(vifm_bin)
 
 $(vifm_bin): $(vifm_src)
 	$(MAKE) $(make_args) vifm$(exe_suffix)
@@ -225,13 +232,7 @@
 	$(CC) -c -o $@ $(CFLAGS) $<
 
 $(B)stic/stic.h.gch: stic/stic.h | $(B)stic
-# don't precompile header with clang (on OS X gcc is likely to be a symlink to
-# clang) because it handles macros in a different way
-ifeq (,$(findstring clang,$(CC)))
-ifneq (Darwin,$(shell uname -s))
 	$(CC) -c -o $@ $(CFLAGS) $<
-endif
-endif
 
 $(B)stic $(B)bin/$(BINSUBDIR):
 	$(AT)mkdir -p $@
@@ -278,7 +279,7 @@
           | $(vifm_bin) $(B)bin/$(BINSUBDIR)
 	$$(LD) -o $$@ $$^ $(LDFLAGS)
 
-$(BUILD)$1/%.o: $1/%.c $(B)stic/stic.h.gch $(BUILD)$1/filelist \
+$(BUILD)$1/%.o: $1/%.c $(GCH_DEP) $(BUILD)$1/filelist \
               | $(BUILD)$1 $(SANDBOX_PATH)/$1
 	$$(CC) -c -o $$@ -include stic/stic.h $(CFLAGS) \
 	                 -DTESTID=$$(call pos, $$($1.obj), $$@) \

=== debian/changelog ===
vifm (0.10.1-4) unstable; urgency=medium

  * Fix GCC-10 (Closes: #957910)
  * Bump standards version to 4.5.0.
  * Bump debhelper compat level to 13.
  * Set Rules-Requires-Root: no.

 -- Ondřej Nový <onovy@debian.org>  Thu, 20 Aug 2020 08:44:41 +0200

vifm (0.10.1-3) unstable; urgency=medium

  * Fix FTBFS on kfreebsd.

 -- Ondřej Nový <onovy@debian.org>  Sat, 24 Aug 2019 18:51:30 +0200

vifm (0.10.1-2) unstable; urgency=medium

  * Fix FTBFS on Hurd.

 -- Ondřej Nový <onovy@debian.org>  Sun, 11 Aug 2019 13:35:56 +0200

vifm (0.10.1-1) unstable; urgency=medium

  * New upstream release.
  * Use debhelper-compat instead of debian/compat.
  * Bump debhelper compat level to 12.
  * Bump standards version to 4.4.0 (no changes).
  * d/patches/drop-vifm-media-osx.patch: Don't install vifm-media-osx script

 -- Ondřej Nový <onovy@debian.org>  Fri, 02 Aug 2019 10:47:46 +0200

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,16 @@
 Section: utils
 Priority: optional
 Maintainer: Ondřej Nový <onovy@debian.org>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 13),
                libmagic-dev,
                libncursesw5-dev,
                libx11-dev,
                vim,
-Standards-Version: 4.2.1
+Standards-Version: 4.5.0
 Homepage: https://vifm.info/
 Vcs-Browser: https://salsa.debian.org/debian/vifm
 Vcs-Git: https://salsa.debian.org/debian/vifm.git
+Rules-Requires-Root: no
 
 Package: vifm
 Architecture: any

=== debian/tests/control ===
Test-Command: vifm -v

=== debian/watch ===
version=3
# X.Y.Z-beta comes before X.Y.Z
opts=\
pgpsigurlmangle=s/$/.asc/,\
uversionmangle=s/-/~/ \
    https://sf.net/vifm/vifm-(.*)\.tar\.bz2

## vifm 0.12

=== tests/Makefile ===
--- 
+++ 
@@ -48,6 +48,9 @@
     endif
 else
     ifeq ($(CROSS),)
+        ifeq ($(shell id -u),0)
+            $(warning warning: running tests as root disables chmod-based ones)
+        endif
         unix_env := true
     else
         win_env := true
@@ -64,21 +67,21 @@
 BUILD := $(B)bin/build/$(BINSUBDIR)
 
 # engine
-suites += abbrevs autocmds commands completion keys options parsing text_buffer
-suites += variables
+suites += abbrevs autocmds cmds commands completion keys options parsing
+suites += text_buffer variables
 # io
 suites += ioeta ionotif iop ior
 # ui
 suites += colmgr column_view viewcolumns_parser
 # everything else
-suites += bmarks env escape fileops filetype filter misc undo utils
+suites += bmarks env escape fileops filetype filter lua misc undo utils
 
 # these are built, but not automatically executed
 apps := fuzz regs_shmem_app
 
 # obtain list of sources that are being tested
-vifm_src := ./ cfg/ compat/ engine/ int/ io/ io/private/ modes/dialogs/ menus/
-vifm_src += modes/ ui/ utils/
+vifm_src := ./ cfg/ compat/ engine/ int/ io/ io/private/ lua/ lua/lua/ menus/
+vifm_src += modes/ modes/dialogs/ ui/ utils/
 vifm_src := $(wildcard $(addprefix ../src/, $(addsuffix *.c, $(vifm_src))))
 vifm_src := $(filter-out %/tags.c %/xxhash.c, $(vifm_src))
 
@@ -92,8 +95,11 @@
     vifm_src := $(filter-out %/wcwidth.c %/volumes_menu.c %_win.c, $(vifm_src))
 endif
 
-vifm_bin := $(B)../src/vifm$(exe_suffix)
-vifm_obj := $(B)../src/./tags.o $(vifm_src:%.c=$(B)%.o) $(BUILD)stubs.o
+vifm_obj := $(B)../src/./tags.o $(vifm_src:%.c=$(B)%.o)
+
+tests_lib := $(BUILD)libtest-support.a
+tests_lib_src := $(wildcard test-support/*.c)
+tests_lib_obj := $(patsubst %.c,$(BUILD)%.o,$(tests_lib_src))
 
 # make sure that there is one compile_info.c object file in the list
 vifm_obj := $(filter-out %/compile_info.o, $(vifm_obj))
@@ -107,7 +113,8 @@
     exe_suffix := .exe
 endif
 
-CC = gcc
+CC = $(CROSS)gcc
+AR = $(CROSS)ar
 
 # handling of verbosity (non-verbose by default)
 ifdef VERBOSE
@@ -116,20 +123,26 @@
     V = 0
 endif
 ACTUAL_CC := $(CC)
+ACTUAL_AR := $(AR)
 CC_0 = @echo "Compiling $@..."; $(ACTUAL_CC)
 CC_1 = $(ACTUAL_CC)
+AR_0 = @echo "Archiving $@..."; $(ACTUAL_AR)
+AR_1 = $(ACTUAL_AR)
 LD_0 = @echo "Linking $@..."; $(ACTUAL_CC)
 LD_1 = $(ACTUAL_CC)
 AT_0 = @
 AT_1 =
 # redefine commands according to verbosity state
 override CC = $(CC_$(V))
+override AR = $(AR_$(V))
 override LD = $(LD_$(V))
 AT = $(AT_$(V))
 
 # setup compile and link flags (partially depends on OS)
-override CFLAGS := $(CFLAGS) -MMD -pipe -Wall -Wno-char-subscripts \
-                   -Istic/ -include $(B)../build-aux/config.h -fsigned-char \
+override CFLAGS := $(CFLAGS) -MMD -MP -pipe \
+                   -Wall -Wno-char-subscripts \
+                   -Itest-support/ -Itest-support/stic/ \
+                   -include $(B)../build-aux/config.h \
                    -DTEST -D_XOPEN_SOURCE -D_XOPEN_SOURCE_EXTENDED \
                    -D_FILE_OFFSET_BITS=64
 override LDFLAGS := $(LDFLAGS)
@@ -160,6 +173,7 @@
         override LDFLAGS += -lcurses
     endif
 endif
+override CFLAGS += -fcommon
 ifeq (,$(findstring -lpthread,$(LDFLAGS)))
     override LDFLAGS += -pthread
 endif
@@ -171,12 +185,14 @@
         override LDFLAGS += --coverage
     endif
 endif
-# don't precompile header with clang (on OS X gcc is likely to be a symlink to
-# clang) because it handles macros in a different way
 ifeq (,$(findstring clang,$(CC)))
+    # don't precompile header with clang (on OS X gcc is likely to be a symlink
+    # to clang) because it handles macros in a different way
     ifneq (Darwin,$(shell uname -s))
-        GCH_DEP := $(B)stic/stic.h.gch
-    endif
+        GCH_DEP := $(BUILD)test-support/stic/stic.h.gch
+    endif
+    # this flag seems to be gcc-specific and clang freaks out on it with -Werror
+    override CFLAGS += -Wno-format-truncation
 endif
 
 ifdef DEBUG
@@ -184,6 +200,8 @@
     override LDFLAGS += -g
     ifdef unix_env
         override LDFLAGS += -rdynamic
+    else
+        override CFLAGS += -gdwarf-3
     endif
 
     ifeq ($(DEBUG),gdb)
@@ -203,7 +221,7 @@
     endif
 endif
 
-.PHONY: check build clean $(suites) $(apps)
+.PHONY: check build clean $(suites) $(apps) appsources
 
 # check and build targets are defined mostly in suite_template
 check: build
@@ -215,26 +233,33 @@
 
 clean:
 	$(RM) -r $(B)bin/ $(SANDBOX_PATH)/
-	$(RM) $(B)stic/stic.h.d $(B)stic/stic.h.gch
 
 # disable implicit rules to prevent compiling main sources here
 .SUFFIXES:
 
-$(vifm_obj) ../src/./tags.c: $(vifm_src) | $(vifm_bin)
-
-$(vifm_bin): $(vifm_src)
+# sources target groups dependencies to avoid invoking nested make per target
+$(vifm_obj) ../src/./tags.c: appsources
+	@# this receipt is needed to make Make recognize that targets were updated
+
+appsources: $(vifm_src)
 	$(MAKE) $(make_args) vifm$(exe_suffix)
 
-$(BUILD)stubs.o: stubs.c
+$(BUILD)test-support/%.o: test-support/%.c | $(BUILD)test-support
 	$(CC) -c -o $@ $(CFLAGS) $<
 
-$(BUILD)stic.o: stic/stic.c
+$(BUILD)test-support/stic/stic.o: test-support/stic/stic.c \
+                                | $(BUILD)test-support/stic
 	$(CC) -c -o $@ $(CFLAGS) $<
 
-$(B)stic/stic.h.gch: stic/stic.h | $(B)stic
+$(BUILD)test-support/stic/stic.h.gch: test-support/stic/stic.h \
+                                    | $(BUILD)test-support/stic
 	$(CC) -c -o $@ $(CFLAGS) $<
 
-$(B)stic $(B)bin/$(BINSUBDIR):
+$(tests_lib): $(BUILD)test-support/stic/stic.o $(tests_lib_obj) \
+            | $(BUILD)
+	$(AR) cr $@ $^
+
+$(BUILD) $(B)bin/$(BINSUBDIR) $(BUILD)test-support $(BUILD)test-support/stic:
 	$(AT)mkdir -p $@
 
 # this function of two arguments (array and element) returns index of the
@@ -275,13 +300,12 @@
 
 deps += $$($1.obj:.o=.d)
 
-$$($1.bin): $$($1.obj) $(BUILD)stic.o $(vifm_obj) \
-          | $(vifm_bin) $(B)bin/$(BINSUBDIR)
+$$($1.bin): $$($1.obj) $(vifm_obj) $(tests_lib) | $(B)bin/$(BINSUBDIR)
 	$$(LD) -o $$@ $$^ $(LDFLAGS)
 
 $(BUILD)$1/%.o: $1/%.c $(GCH_DEP) $(BUILD)$1/filelist \
               | $(BUILD)$1 $(SANDBOX_PATH)/$1
-	$$(CC) -c -o $$@ -include stic/stic.h $(CFLAGS) \
+	$$(CC) -c -o $$@ $(CFLAGS) -include test-support/stic/stic.h \
 	                 -DTESTID=$$(call pos, $$($1.obj), $$@) \
 	                 -DMAXTESTID=$$(words $$($1.obj)) $$< \
 	                 -DSUITE_NAME="$1" \
@@ -336,4 +360,5 @@
 
 # import dependencies calculated by the compiler
 include $(wildcard $(deps) \
-                   $(B)bin/build/stic.d $(B)stic/stic.h.d $(B)bin/build/stubs.d)
+                   $(BUILD)test-support/stic/stic.h.d \
+                   $(BUILD)test-support/*.d)

=== debian/changelog ===
vifm (0.12-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:31:11 +1100

vifm (0.12-1build1) noble; urgency=medium

  * No-change rebuild for libmagic t64.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 13:43:12 +0100

vifm (0.12-1) unstable; urgency=medium

  * New upstream release.
  * d/watch: Change to GitHub.
  * Drop patches which are not needed or applied upstream:
    - drop-vifm-media-osx.patch
    - fix-hurd.patch
    - fix-kfreebsd.patch
    - gcc-10-fix.patch
  * d/rules:
    - Set TERM=xterm
    - Don't remove /usr/share/vifm/vifmrc-osx (doesn't exists in new release)

 -- Ondřej Nový <onovy@debian.org>  Wed, 13 Oct 2021 15:18:06 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: vifm
 Section: utils
 Priority: optional
-Maintainer: Ondřej Nový <onovy@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Ondřej Nový <onovy@debian.org>
 Build-Depends: debhelper-compat (= 13),
                libmagic-dev,
                libncursesw5-dev,

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,7 @@
 
 export LC_ALL=C.UTF-8
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export TERM=xterm
 
 %:
 	dh $@
@@ -22,8 +23,7 @@
 		debian/vifm/usr/share/doc/vifm/INSTALL \
 		debian/vifm/usr/share/doc/vifm/ChangeLog \
 		debian/vifm/usr/share/vifm/vim \
-		debian/vifm/usr/share/vifm/vim-doc \
-		debian/vifm/usr/share/vifm/vifmrc-osx
+		debian/vifm/usr/share/vifm/vim-doc
 
 	dh_install
